diff -r f77229934d59 src/org/armedbear/lisp/Utilities.java
--- a/src/org/armedbear/lisp/Utilities.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Utilities.java	Tue Jan 26 12:34:38 2010 +0100
@@ -33,6 +33,7 @@
 
 package org.armedbear.lisp;
 
+import java.util.jar.JarFile;
 import static org.armedbear.lisp.Lisp.*;
 
 import java.io.ByteArrayInputStream;
@@ -124,50 +125,112 @@
             return null;
         }
     }
+
+    public static ZipInputStream getZipInputStream(ZipFile zipfile,
+                                                   String entryName) {
+        return Utilities.getZipInputStream(zipfile, entryName, false);
+    }
+
+  public static ZipInputStream getZipInputStream(ZipFile zipfile,
+                                                 String entryName,
+                                                 boolean errorOnFailure) {
+    ZipEntry zipEntry = zipfile.getEntry(entryName);
+    ZipInputStream stream = null;
+    try {
+      stream = new ZipInputStream(zipfile.getInputStream(zipEntry));
+    } catch (IOException e) {
+      if (errorOnFailure) {
+          Lisp.error(new FileError("Failed to open '" + entryName + "' in zipfile '"
+                                   + zipfile + "': " + e.getMessage()));
+      }
+      return null;
+    }
+    return stream;
+  }
+
     
     public static byte[] getZippedZipEntryAsByteArray(ZipFile zipfile,
                                                       String entryName,
                                                       String subEntryName) 
 
   {
-      ZipEntry entry = zipfile.getEntry(entryName);
-      
-      ZipInputStream stream = null;
+      ZipInputStream stream = getZipInputStream(zipfile, entryName,  true);
+      ZipEntry entry = getEntry(stream, subEntryName);
+      ByteArrayOutputStream buffer = new ByteArrayOutputStream();
+      int count;
+      byte buf[] = new byte[1024];
       try {
-          stream = new ZipInputStream(zipfile.getInputStream(entry));
-      } 
-      catch (IOException e) {
-          Lisp.error(new FileError("Failed to open '" + entryName + "' in zipfile '"
-                                   + zipfile + "': " + e.getMessage()));
+        while ((count = stream.read(buf, 0, buf.length)) != -1) {
+          buffer.write(buf, 0, count);
+        }
+      } catch (java.io.IOException e) {
+        Lisp.error(new FileError("Failed to read compressed '"
+                                 + subEntryName 
+                                 + "' in '" 
+                                 + zipfile.getName() + ":" + entryName + ":"
+                                 + e.getMessage()));
       }
-      //  XXX Cache the zipEntries somehow
-      do {
-          try { 
-              entry = stream.getNextEntry();
-          } catch (IOException e){
-              Lisp.error(new FileError("Failed to seek for '" + subEntryName 
-                                       + "' in '" 
-                                       + zipfile.getName() + ":" + entryName + ".:"
-                                       + e.getMessage()));
-          }
-      } while (!entry.getName().equals(subEntryName));
-      
-      ByteArrayOutputStream buffer = new ByteArrayOutputStream();
+      return buffer.toByteArray();
+    }
+    
+    public static InputStream getEntryAsInputStream(ZipInputStream zipInputStream,
+                                                    String entryName)
+    {
+        ZipEntry entry = getEntry(zipInputStream, entryName);
+        ByteArrayOutputStream bytes = readEntry(zipInputStream);
+        return new ByteArrayInputStream(bytes.toByteArray());
+
+    }
+
+    public static ByteArrayOutputStream readEntry(ZipInputStream stream) {
+        ByteArrayOutputStream result = new ByteArrayOutputStream();
         int count;
         byte buf[] = new byte[1024];
         try {
             while ((count = stream.read(buf, 0, buf.length)) != -1) {
-                buffer.write(buf, 0, count);
+                result.write(buf, 0, count);
             }
         } catch (java.io.IOException e) {
-          Lisp.error(new FileError("Failed to read compressed '"
-                                   + subEntryName 
-                                   + "' in '" 
-                                   + zipfile.getName() + ":" + entryName + ":"
-                                   + e.getMessage()));
+            Debug.trace("Failed to read entry from " 
+                        + stream
+                        + ": " + e);
+            return null;
         }
-        return buffer.toByteArray();
+        return result;
     }
+
+    public static ZipEntry getEntry(ZipInputStream zipInputStream, String entryName) {
+        return Utilities.getEntry(zipInputStream, entryName, false);
+    }
+
+  public static ZipEntry getEntry(ZipInputStream zipInputStream,
+                                  String entryName,
+                                  boolean errorOnFailure)
+  {
+    ZipEntry entry = null;
+    do {
+      try {
+        entry = zipInputStream.getNextEntry();
+      } catch (IOException e) {
+        if (errorOnFailure) {
+          Lisp.error(new FileError("Failed to seek for "
+            + "'" + entryName + "'"
+            + " in " + zipInputStream.toString()));
+        }
+        return null;
+      }
+    } while (entry != null && !entry.getName().equals(entryName));
+    if (entry != null) {
+      return entry;
+    }
+    if (errorOnFailure) {
+      Lisp.error(new FileError("Failed to find "
+        + "'" + entryName + "'"
+        + " in " + zipInputStream.toString()));
+    }
+    return null;
+
+  }
     
     public static InputStream getZippedZipEntryAsInputStream(ZipFile zipfile,
                                                              String entryName,
@@ -179,5 +242,63 @@
                                      .getZippedZipEntryAsByteArray(zipfile, entryName, 
                                                                    subEntryName));
   }
+
+    public static final boolean checkZipFile(Pathname name) {
+        InputStream input = name.getInputStream();
+        try {
+            byte[] bytes = new byte[4];
+            int bytesRead = input.read(bytes);
+            return (bytesRead == 4
+                    && bytes[0] == 0x50
+                    && bytes[1] == 0x4b
+                    && bytes[2] == 0x03
+                    && bytes[3] == 0x04);
+        } catch (Throwable t) { // any error probably means 'no'
+            return false;
+        } finally {
+            if (input != null) {
+                try {
+                    input.close();
+                }
+                catch (IOException e) {} // ignore exceptions
+            }
+        }
+    }
+
+        
+    @Deprecated
+    private static final boolean checkZipFile(File file) {
+        Pathname name = Pathname.makePathname(file);
+        return checkZipFile(name);
+    }
+
+    static InputStream getInputStream(JarFile jarFile, Pathname inner) {
+        String entryPath = inner.asEntryPath();
+        ZipEntry entry = jarFile.getEntry(entryPath);
+        if (entry == null) {
+            Debug.trace("Failed to find entry "
+                    + "'" + entryPath + "'"
+                    + " in " 
+                    + "'" + jarFile.getName() + "'");
+            return null;
+        }
+        InputStream result = null;
+        try {
+            result = jarFile.getInputStream(entry);
+        } catch (IOException e) {
+            Debug.trace("Failed to open InputStream for "
+              + "'" + entryPath + "'"
+              + " in "
+              + "'" + jarFile.getName() + "'");
+            return null;
+        }
+        return result;
+    }
+
+
+
 }
 
+// Local Variables:
+// c-basic-offset: 4
+// End:
diff -r f77229934d59 src/org/armedbear/lisp/Version.java
--- a/src/org/armedbear/lisp/Version.java	Tue Jan 26 12:30:57 2010 +0100
+++ b/src/org/armedbear/lisp/Version.java	Tue Jan 26 12:34:38 2010 +0100
@@ -43,4 +43,8 @@
   {
     return "0.19.0-dev";
   }
+  
+  public static void main(String args[]) {
+    System.out.println(Version.getVersion());
+  }
 }
diff -r f77229934d59 src/org/armedbear/lisp/unzip.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/org/armedbear/lisp/unzip.java	Tue Jan 26 12:34:38 2010 +0100
@@ -0,0 +1,121 @@
+/*
+ * unzip.java
+ *
+ * Copyright (C) 2005 Peter Graves
+ * $Id: unzip.java 12288 2009-11-29 22:00:12Z vvoutilainen $
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ *
+ * As a special exception, the copyright holders of this library give you
+ * permission to link this library with independent modules to produce an
+ * executable, regardless of the license terms of these independent
+ * modules, and to copy and distribute the resulting executable under
+ * terms of your choice, provided that you also meet, for each linked
+ * independent module, the terms and conditions of the license of that
+ * module.  An independent module is a module which is not derived from
+ * or based on this library.  If you modify this library, you may extend
+ * this exception to your version of the library, but you are not
+ * obligated to do so.  If you do not wish to do so, delete this
+ * exception statement from your version.
+ */
+
+package org.armedbear.lisp;
+
+import static org.armedbear.lisp.Lisp.*;
+import java.io.File;
+import java.io.InputStream;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.util.Enumeration;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+
+// ### unzip pathname directory => unzipped_pathnames
+public final class unzip 
+  extends Primitive
+{
+  public unzip() {
+    super("unzip", PACKAGE_SYS, true, "pathname &optional directory => unzipped_pathnames");
+  }
+  
+  @Override
+  public LispObject execute(LispObject first) {
+    Pathname zipFile = coerceToPathname(first);
+    Pathname directory = coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue());
+    return unzipToDirectory(zipFile, directory);
+  }
+
+  @Override
+  public LispObject execute(LispObject first, LispObject second) {
+    Pathname zipFile = coerceToPathname(first);
+    Pathname directory = coerceToPathname(second);
+    directory.name = NIL;
+    directory.type = NIL;
+    directory.invalidateNamestring();
+    return unzipToDirectory(zipFile, directory);
+  }
+  
+  private LispObject unzipToDirectory(Pathname zipPath, Pathname dirPath) {
+    if (!zipPath.isAbsolute()) {
+      zipPath = Pathname.mergePathnames(zipPath,
+                                          coerceToPathname(Symbol.DEFAULT_PATHNAME_DEFAULTS.symbolValue()));
+    }
+    LispObject o = Pathname.truename(zipPath, false);
+    if (!(o instanceof Pathname)) {
+      return error(new FileError("No file found: " + zipPath, zipPath));
+    }
+    String zip = ((Pathname)o).getNamestring();
+    if (zip == null) {
+      return error(new FileError("Pathname has no namestring: " + zip, zipPath));
+    }
+    String dir = dirPath.getNamestring();
+    if (dir == null) {
+      return error(new FileError("Could not parse diretory: " + dirPath, dirPath));
+    }
+    LispObject result = NIL;
+    try {
+      ZipFile zipfile = new ZipFile(zip);
+   
+      byte[] buffer = new byte[4096];
+      for (Enumeration<? extends ZipEntry> entries =  zipfile.entries();entries.hasMoreElements();) {
+        ZipEntry entry = entries.nextElement();
+        String name = entry.getName();
+        String filename = dir + name;
+        File file = new File(filename);
+        if (entry.isDirectory()) {
+          file.mkdirs();
+          continue;
+        }
+        FileOutputStream out = new FileOutputStream(file);
+        InputStream in = zipfile.getInputStream(entry);
+        int n;
+        while ((n = in.read(buffer)) > 0) {
+          out.write(buffer, 0, n);
+        }
+        out.close();
+        in.close();
+        result = result.push(new Pathname(filename));
+      }
+    } catch (IOException e) {
+        return error(new FileError("Failed to unzip " 
+                                   + "'" + zipPath + "'"
+                                   + " into " + "'" + dirPath + "'"
+                                   + ": " + e, zipPath)); 
+    }
+    return result;
+  }
+
+  private static final Primitive unzip = new unzip();
+}
